/*******************************************************************************
**                          configurator.h
**                             part of
**                konserve -- A small backup application
**			 -------------------
**  begin    : Son Apr 14 16:46:00 CEST 2002
**  copyright: (C) 2002 by Florian Simnacher
**  email    : simnacher@gmx.de
**  $Id: configurator.h,v 1.1.1.1 2003/09/17 07:52:06 florian Exp $
*******************************************************************************/

/*******************************************************************************
**  This program is free software; you can redistribute it and/or             **
**  modify it under the terms of the GNU General Public License               **
**  as published by the Free Software Foundation; either version 2            **
**  of the License, or (at your option) any later version.                    **
**                                                                            **
**  This program is distributed in the hope that it will be useful,           **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of            **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
**  GNU General Public License for more details.                              **
**                                                                            **
**  You should have received a copy of the GNU General Public License         **
**  along with this program; if not, write to the Free Software               **
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    **
**  MA  02111-1307, USA.                                                      **
*******************************************************************************/
#ifndef configurator_h
#define configurator_h

// Qt includes
#include <qstring.h>

// KDE includes
#include <kconfig.h>

// My includes
#include "backupprofile.h"
#include "dumpable.h"
#include "profilemngrinterface.h"

////////////////////////////////////////////////////////////////////////////////
///////                  class Configurator                              ///////
////////////////////////////////////////////////////////////////////////////////

class Configurator : public ProfileMngrInterface, public Dumpable
{
public:
    Configurator();
    ~Configurator();

    void inserted( BackupProfile *b );
    void changed( BackupProfile *b );
    void removed( QString s );

    void doConfigure();

    QString dumpInternal();

private:
    void insertProfile( BackupProfile *b );
    void newProfile( BackupProfile *b );
    void changeProfile( BackupProfile *b );
    void removeProfile( QString q );

    void initProfileCreation();
    bool hasMoreProfiles();
    BackupProfile *nextProfile( QString aProfileName );

    void sync();

private:
    KConfigBase *mpTheConfig;
    QStringList  mProfileNames;
    QString      mConfigFileVersion;
};

#endif
