/*******************************************************************************
**                            dumpable.h
**                             part of
**                konserve -- A small backup application
**			 -------------------
**  begin    : Mit Apr 10 22:39:15 CEST 2002
**  copyright: (C) 2002 by Florian Simnacher
**  email    : simnacher@gmx.de
**  $Id: dumpable.h,v 1.1.1.1 2003/09/17 07:52:06 florian Exp $
*******************************************************************************/

/*******************************************************************************
**  This program is free software; you can redistribute it and/or             **
**  modify it under the terms of the GNU General Public License               **
**  as published by the Free Software Foundation; either version 2            **
**  of the License, or (at your option) any later version.                    **
**                                                                            **
**  This program is distributed in the hope that it will be useful,           **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of            **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
**  GNU General Public License for more details.                              **
**                                                                            **
**  You should have received a copy of the GNU General Public License         **
**  along with this program; if not, write to the Free Software               **
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    **
**  MA  02111-1307, USA.                                                      **
*******************************************************************************/
#ifndef dumpable_h
#define dumpable_h

// Qt includes
#include <qstring.h>
#include <qptrlist.h>

////////////////////////////////////////////////////////////////////////////////
///////                  class Dumpable                                  ///////
////////////////////////////////////////////////////////////////////////////////

class Dumpable
{
public:
    Dumpable( QString class_name, QString instance_name = QString::null );
    Dumpable( const Dumpable& d );
    virtual ~Dumpable();

    void operator=( const Dumpable& d );

    QString dump();
    virtual QString dumpInternal() = 0;
    QString dumpAll();

protected:
    static QPtrList<Dumpable> mDumpableList;
    static QPtrList<Dumpable> mAlreadyDumped;
    static bool               mInDumpAll;

    QString mClassName;
    QString mInstanceName;
};

#endif
