/***************************************************************************
**                      configurationdlgtest.cpp
**                             part of
**                konserve -- A small backup application
**			 -------------------
**  begin    : Sam Aug 24 21:51:13 CEST 2002
**  version  : $Id: configurationdlgtest.cpp,v 1.1.1.1 2003/09/17 07:52:06 florian Exp $
**  copyright: (C) 2002 by Florian Simnacher
**  email    : simnacher@gmx.de
***************************************************************************/

/***************************************************************************
**  This program is free software; you can redistribute it and/or         **
**  modify it under the terms of the GNU General Public License           **
**  as published by the Free Software Foundation; either version 2        **
**  of the License, or (at your option) any later version.                **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program; if not, write to the Free Software           **
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                **
**  MA  02111-1307, USA.                                                  **
***************************************************************************/

#include <kinstance.h>

#include <cppunit/TestFixture.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestResult.h>
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/ui/text/TestRunner.h>

#include <configurationdlg.h>
#include <backupprofile.h>

class ConfigurationDlgTest : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE( ConfigurationDlgTest );
    CPPUNIT_TEST( test_MyBackupProfileInfo );
    CPPUNIT_TEST_SUITE_END();

public:
    void test_MyBackupProfileInfo()
        {
            CPPUNIT_ASSERT( ! mpBpi->modified() );
            mpBpi->modify(
                BackupProfile::newBackupProfileReadOnly(
                    KURL( "file:/home/florian" ),
                    KURL( "file:/tmp/" ),
                    "modiytest",
                    500,
                    "hour",
                    false,
                    QDateTime::currentDateTime()
                    )
                );
            CPPUNIT_ASSERT( mpBpi->modified() );
            mpBpi->discardChanges();
            CPPUNIT_ASSERT( ! mpBpi->modified() );
            mpBpi->modify(
                BackupProfile::newBackupProfileReadOnly(
                    KURL( "file:/home/florian" ),
                    KURL( "file:/tmp/" ),
                    "modiytest",
                    500,
                    "hour",
                    false,
                    QDateTime::currentDateTime()
                    )
                );
            CPPUNIT_ASSERT( mpBpi->modified() );
            mpBpi->applyChanges();
            CPPUNIT_ASSERT( ! mpBpi->modified() );
        }
    void setUp()
        {
            mpBpi = new ConfigurationDlg::MyBackupProfileInfo(
                BackupProfile::newBackupProfileReadOnly(
                    KURL( "file:/home/florian" ),
                    KURL( "file:/tmp/" ),
                    "MyBackupProfileInfo",
                    1000,
                    "sec",
                    false,
                    QDateTime::currentDateTime()
                    )
                );
        }
    void tearDown()
        {
            delete mpBpi;
        }
private:
    ConfigurationDlg::MyBackupProfileInfo* mpBpi;
};

int main( /* int argc, char** argv */ )
{
    KInstance myInstance( "ConfigurationDlgTest" );

    CppUnit::TextUi::TestRunner runner;
    runner.addTest( ConfigurationDlgTest::suite() );
    runner.run();

    return 0;
}



