#include <iostream>
#include <kinstance.h>
#include <kurl.h>


KURL dotCheck( KURL inUrl )
{
    QString url_string = inUrl.url();
    Q_ASSERT( !url_string.endsWith( "/" ) );

    int index = url_string.findRev( "/" );

    if ( -1 == index )
    {
        if ( url_string.startsWith( "." ) )
            return KURL( "dot" + url_string );
        else
            return inUrl;
    }
    if ( -1 < index )
    {
        QString rightstring = url_string.right( url_string.length() - index - 1 );
        QString leftstring  = url_string.left( index + 1 );

        if ( rightstring.startsWith( "." ) )
            return KURL( leftstring + "dot" + rightstring );
    }

    return inUrl;
}

void test_dotCheck( QString _input, QString _expected )
{
    KURL input( _input );
    KURL expected( _expected );

    if ( expected == dotCheck( input ) )
        cout << "Test: " << input.url() << " OK" << endl;
    else
        cout << "Test: " << input.url() << " failed" << endl;
}

int main()
{
    KInstance myInstance( "dotchecktest" );

    test_dotCheck( "/home/florian/.kde", "/home/florian/dot.kde" );
    test_dotCheck( "/home/florian/.foo.tar.gz", "/home/florian/dot.foo.tar.gz" );
    test_dotCheck( "/home/florian/kde", "/home/florian/kde" );
    test_dotCheck( "file:/foofoofoo", "file:/foofoofoo" );
    test_dotCheck( "file:/home/florian/.foofoofoo", "file:/home/florian/dot.foofoofoo" );
    test_dotCheck( "http://www.my.com/pub/.something", "http://www.my.com/pub/dot.something" );

    return 0;
}
