#include <kapp.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kurl.h>
#include <kdebug.h>

#include "helper.h"

int main( int argc, char** argv )
{
    KAboutData kad( "foo",
		    "bar",
		    "0.0.1" );

    KCmdLineArgs::init( argc, argv, &kad );
    KApplication mykapp;

    KURL url1( "file:/home/foo" );
    if ( Helper::isOK( url1, Helper::CHECK_MALFORMED ) )
        kdDebug() << "CHECK_MALFORMED: " << url1.url() << " OK" << endl;
    else
        kdDebug() << "CHECK_MALFORMED failed" << endl;
    if ( Helper::isOK( url1, Helper::CHECK_LOCAL_FILE ) )
        kdDebug() << "CHECK_LOCAL_FILE: " << url1.url() << " OK" << endl;
    else
        kdDebug() << "CHECK_LOCAL_FILE failed" << endl;
    if ( Helper::isOK( url1, Helper::CHECK_EMPTY ) )
        kdDebug() << "CHECK_EMPTY: " << url1.url() << " OK" << endl;
    else
        kdDebug() << "CHECK_EMPTY failed" << endl;

    KURL url2( "__082048040!!$$$$lljfs/home/foo" );
    if ( Helper::isOK( url2, Helper::CHECK_MALFORMED ) )
        kdDebug() << "CHECK_MALFORMED: " << url2.url() << " failed" << endl;
    else
        kdDebug() << "CHECK_MALFORMED" << url2.url() << " OK" << endl;
    if ( Helper::isOK( url2, Helper::CHECK_LOCAL_FILE ) )
        kdDebug() << "CHECK_LOCAL_FILE: " << url2.url() << " failed" << endl;
    else
        kdDebug() << "CHECK_LOCAL_FILE: " << url2.url() << " OK" << endl;
    if ( Helper::isOK( url2, Helper::CHECK_EMPTY ) )
        kdDebug() << "CHECK_EMPTY: " << url2.url() << " OK" << endl;
    else
        kdDebug() << "CHECK_EMPTY failed" << endl;

    KURL url3( "" );
    if ( Helper::isOK( url3, Helper::CHECK_MALFORMED ) )
        kdDebug() << "CHECK_MALFORMED: " << url3.url() << " failed" << endl;
    else
        kdDebug() << "CHECK_MALFORMED failed" << url3.url() << " OK" << endl;
    if ( Helper::isOK( url3, Helper::CHECK_LOCAL_FILE ) )
        kdDebug() << "CHECK_LOCAL_FILE: " << url3.url() << " failed" << endl;
    else
        kdDebug() << "CHECK_LOCAL_FILE failed" << url3.url() << " OK" << endl;
    if ( Helper::isOK( url3, Helper::CHECK_EMPTY ) )
        kdDebug() << "CHECK_EMPTY: " << url3.url() << " failed" << endl;
    else
        kdDebug() << "CHECK_EMPTY "  << url3.url() << " OK" << endl;

    KURL url4( "http://www.foo.com" );
    if ( Helper::isOK( url4, Helper::CHECK_MALFORMED ) )
        kdDebug() << "CHECK_MALFORMED: " << url4.url() << " OK" << endl;
    else
        kdDebug() << "CHECK_MALFORMED " << url4.url() << " failed" << endl;
    if ( Helper::isOK( url4, Helper::CHECK_LOCAL_FILE ) )
        kdDebug() << "CHECK_LOCAL_FILE: " << url4.url() << " failed" << endl;
    else
        kdDebug() << "CHECK_LOCAL_FILE" << url4.url() << " OK" << endl;
    if ( Helper::isOK( url4, Helper::CHECK_EMPTY ) )
        kdDebug() << "CHECK_EMPTY: " << url4.url() << " OK" << endl;
    else
        kdDebug() << "CHECK_EMPTY failed" << endl;

    if ( Helper::homeDir() == "/home/florian" )
        kdDebug() << "homeDir() OK" << endl;
    else
        kdDebug() << "homeDir() failed" << endl;
    if ( Helper::userName() == "florian" )
        kdDebug() << "userName() OK" << endl;
    else
        kdDebug() << "userName() failed" << endl;
    if ( Helper::userGroup() == "users" )
        kdDebug() << "userGroup() OK" << endl;
    else
        kdDebug() << "userGroup() failed" << endl;

    mykapp.exit();
    return 0;
}
