/*******************************************************************************
**                          timeinterval.h
**                             part of
**                konserve -- A small backup application
**			 -------------------
**  begin    : Sam Apr 13 11:46:02 CEST 2002
**  copyright: (C) 2002 by Florian Simnacher
**  email    : simnacher@gmx.de
**  $Id: timeinterval.h,v 1.1.1.1 2003/09/17 07:52:06 florian Exp $
*******************************************************************************/

/*******************************************************************************
**  This program is free software; you can redistribute it and/or             **
**  modify it under the terms of the GNU General Public License               **
**  as published by the Free Software Foundation; either version 2            **
**  of the License, or (at your option) any later version.                    **
**                                                                            **
**  This program is distributed in the hope that it will be useful,           **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of            **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
**  GNU General Public License for more details.                              **
**                                                                            **
**  You should have received a copy of the GNU General Public License         **
**  along with this program; if not, write to the Free Software               **
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    **
**  MA  02111-1307, USA.                                                      **
*******************************************************************************/
#ifndef timeinterval_h
#define timeinterval_h

// Qt includes
#include <qstring.h>

// My includes
#include "dumpable.h"

////////////////////////////////////////////////////////////////////////////////
//////////                  class TimeInterval                           ///////
////////////////////////////////////////////////////////////////////////////////

class TimeInterval : public Dumpable
{
public:

    // Values for measurement
    static const unsigned int TIME_SEC  = 0;
    static const unsigned int TIME_MIN  = 1;
    static const unsigned int TIME_HOUR = 2;
    static const unsigned int TIME_DAY  = 3;

    TimeInterval( unsigned int value, unsigned int measurement );
    TimeInterval( unsigned int value, QString measurment);
    TimeInterval( const TimeInterval& t );
    ~TimeInterval();

    unsigned int secs() const { return mSecs; }
    unsigned int value() const;
    QString      measurement() const ;
    int          measurement( int dummy ) const
        { dummy++; return mMeasurement; }

    QString dumpInternal();

private:
    unsigned int mSecs;
    unsigned int mMeasurement;
};

#endif
